## Notification Listener App

### Overview
This Android application enhances user experience by filtering and highlighting important notifications. It allows users to specify a sound effect and a keyword. When enabled, the app monitors notifications from selected apps for occurrences of the keyword. Upon detection, it replaces the default notification sound with the user-selected sound, ensuring important notifications are never overlooked.

### Features
- **Keyword Detection:** Specify a keyword that the app will watch for in incoming notifications.
- **Custom Sound Effects:** Choose a unique sound effect to play when the keyword is detected.
- **Selective Listening:** Select which apps the listener should monitor for notifications.
- **Enhanced Notification Management:** Ensures that notifications containing the keyword stand out from others.

### Usage
1. **Select Sound Effect:** Choose a preferred sound effect for notifications.
2. **Set Keyword:** Enter a specific keyword that the app will search for in notifications.
3. **Choose Apps:** Select the apps from which notifications should be monitored.
4. **Activate Listener:** Enable the app's listener to start monitoring incoming notifications.
5. **Permission Requirements:** Make sure to enable necessary permissions for the app to function properly.

### Download
- **F-Droid:** You can download the latest version of the app from [F-Droid](https://f-droid.org/en/packages/com.example.notificationalerter/).

### Purpose
This app aims to improve user productivity by prioritizing important notifications and reducing distractions from less critical alerts. It ensures that users are promptly notified of crucial information, making daily smartphone use more efficient and focused.
